diff -crN nakedmudv1.4/src/scripts/script.c nakedmudv1.5/src/scripts/script.c
*** nakedmudv1.4/src/scripts/script.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/scripts/script.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 82,91 ****
    STORAGE_SET_LIST *list = new_storage_list();
    LIST          *scripts = scriptSetList(data->scripts, SCRIPT_TYPE_ANY);
    SCRIPT_DATA    *script = NULL;
!   store_list(set, "scripts", list, NULL);
    while((script = listPop(scripts)) != NULL) {
      STORAGE_SET *scriptset = new_storage_set();
!     store_int(scriptset, "vnum", scriptGetVnum(script), NULL);
      storage_list_put(list, scriptset);
    }
    deleteList(scripts);
--- 82,91 ----
    STORAGE_SET_LIST *list = new_storage_list();
    LIST          *scripts = scriptSetList(data->scripts, SCRIPT_TYPE_ANY);
    SCRIPT_DATA    *script = NULL;
!   store_list(set, "scripts", list);
    while((script = listPop(scripts)) != NULL) {
      STORAGE_SET *scriptset = new_storage_set();
!     store_int(scriptset, "vnum", scriptGetVnum(script));
      storage_list_put(list, scriptset);
    }
    deleteList(scripts);
***************
*** 197,208 ****
  
  STORAGE_SET *scriptStore(SCRIPT_DATA *script) {
    STORAGE_SET *set = new_storage_set();
!   store_int   (set, "vnum", script->vnum, NULL);
!   store_int   (set, "type", script->type, NULL);
!   store_int   (set, "narg", script->num_arg, NULL);
!   store_string(set, "name", script->name, NULL);
!   store_string(set, "args", script->args, NULL);
!   store_string(set, "code", script->code, NULL);
    return set;
  }
  
--- 197,208 ----
  
  STORAGE_SET *scriptStore(SCRIPT_DATA *script) {
    STORAGE_SET *set = new_storage_set();
!   store_int   (set, "vnum", script->vnum);
!   store_int   (set, "type", script->type);
!   store_int   (set, "narg", script->num_arg);
!   store_string(set, "name", script->name);
!   store_string(set, "args", script->args);
!   store_string(set, "code", script->code);
    return set;
  }
  
***************
*** 343,349 ****
  
  
  void run_script(const char *script, void *me, int me_type,
! 		CHAR_DATA *ch, OBJ_DATA *obj, ROOM_DATA *room, EXIT_DATA *exit, 
  		const char *cmd, const char *arg, int narg) {
    static char buf[MAX_SCRIPT];
    *buf = '\0';
--- 343,349 ----
  
  
  void run_script(const char *script, void *me, int me_type,
! 		CHAR_DATA *ch, OBJ_DATA *obj, ROOM_DATA *room, 
  		const char *cmd, const char *arg, int narg) {
    static char buf[MAX_SCRIPT];
    *buf = '\0';
***************
*** 354,360 ****
    i += snprintf(buf+i, MAX_SCRIPT - i - 1, "from char import *\n");
    i += snprintf(buf+i, MAX_SCRIPT - i - 1, "from room import *\n");
    i += snprintf(buf+i, MAX_SCRIPT - i - 1, "from obj import *\n");
-   //    i += snprintf(buf+i, MAX_SCRIPT - i - 1, "from exit import *\n");
  
    // print the different variables
    i += snprintf(buf+i, MAX_SCRIPT - i - 1, "cmd = '%s'\n", (cmd ? cmd : ""));
--- 354,359 ----
***************
*** 368,375 ****
      i += snprintf(buf+i, MAX_SCRIPT - i - 1, "me = Obj(%d)\n", objGetUID(me));
    else if(me_type == SCRIPTOR_ROOM)
      i += snprintf(buf+i, MAX_SCRIPT - i - 1, "me = Room(%d)\n",roomGetVnum(me));
-   else if(me_type == SCRIPTOR_EXIT)
-     ;
  
    // print all of the other things involved
    if(ch)
--- 367,372 ----
***************
*** 562,568 ****
      if(is_keyword(scriptGetArgs(script), speech, FALSE)) {
        run_script(scriptGetCode(script),
  		 listener, SCRIPTOR_CHAR,
! 		 ch, NULL, charGetRoom(listener), NULL, NULL, speech, 0);
      }
    }
    deleteList(speech_scripts);
--- 559,565 ----
      if(is_keyword(scriptGetArgs(script), speech, FALSE)) {
        run_script(scriptGetCode(script),
  		 listener, SCRIPTOR_CHAR,
! 		 ch, NULL, charGetRoom(listener), NULL, speech, 0);
      }
    }
    deleteList(speech_scripts);
***************
*** 580,591 ****
  }
  
  
! void try_enterance_script(CHAR_DATA *ch, ROOM_DATA *room, 
! 			  EXIT_DATA *exit, const char *dirname) {
    // check the room
    try_scripts(SCRIPT_TYPE_ENTER,
  	      room, SCRIPTOR_ROOM,
! 	      ch, NULL, room, exit, dirname, NULL, 0);
  
    // check everyone in the room
    LIST_ITERATOR *char_i = newListIterator(roomGetCharacters(room));
--- 577,587 ----
  }
  
  
! void try_enterance_script(CHAR_DATA *ch, ROOM_DATA *room, const char *dirname) {
    // check the room
    try_scripts(SCRIPT_TYPE_ENTER,
  	      room, SCRIPTOR_ROOM,
! 	      ch, NULL, room, dirname, NULL, 0);
  
    // check everyone in the room
    LIST_ITERATOR *char_i = newListIterator(roomGetCharacters(room));
***************
*** 595,612 ****
        continue;
      try_scripts(SCRIPT_TYPE_ENTER,
  		greeter, SCRIPTOR_CHAR,
! 		ch, NULL, room, exit, dirname, NULL, 0);
    }
    deleteListIterator(char_i);
  }
  
  
! void try_exit_script(CHAR_DATA *ch, ROOM_DATA *room, 
! 		     EXIT_DATA *exit, const char *dirname) {
    // check the room
    try_scripts(SCRIPT_TYPE_EXIT,
  	      room, SCRIPTOR_ROOM,
! 	      ch, NULL, room, exit, dirname, NULL, 0);
  
    // check everyone in the room
    LIST_ITERATOR *char_i = newListIterator(roomGetCharacters(room));
--- 591,607 ----
        continue;
      try_scripts(SCRIPT_TYPE_ENTER,
  		greeter, SCRIPTOR_CHAR,
! 		ch, NULL, room, dirname, NULL, 0);
    }
    deleteListIterator(char_i);
  }
  
  
! void try_exit_script(CHAR_DATA *ch, ROOM_DATA *room, const char *dirname) {
    // check the room
    try_scripts(SCRIPT_TYPE_EXIT,
  	      room, SCRIPTOR_ROOM,
! 	      ch, NULL, room, dirname, NULL, 0);
  
    // check everyone in the room
    LIST_ITERATOR *char_i = newListIterator(roomGetCharacters(room));
***************
*** 617,623 ****
        continue;
      try_scripts(SCRIPT_TYPE_EXIT,
  		watcher, SCRIPTOR_CHAR,
! 		ch, NULL, room, exit, dirname, NULL, 0);
    }
    deleteListIterator(char_i);
  }
--- 612,618 ----
        continue;
      try_scripts(SCRIPT_TYPE_EXIT,
  		watcher, SCRIPTOR_CHAR,
! 		ch, NULL, room, dirname, NULL, 0);
    }
    deleteListIterator(char_i);
  }
***************
*** 630,636 ****
    // to halt the normal command from going through
    if(try_scripts(SCRIPT_TYPE_COMMAND,
  		 charGetRoom(ch), SCRIPTOR_ROOM,
! 		 ch, NULL, charGetRoom(ch), NULL, cmd, arg, 0))
      retval = 1;
  
    // check everyone in the room
--- 625,631 ----
    // to halt the normal command from going through
    if(try_scripts(SCRIPT_TYPE_COMMAND,
  		 charGetRoom(ch), SCRIPTOR_ROOM,
! 		 ch, NULL, charGetRoom(ch), cmd, arg, 0))
      retval = 1;
  
    // check everyone in the room
***************
*** 642,648 ****
        continue;
      if(try_scripts(SCRIPT_TYPE_COMMAND,
  		   scriptor, SCRIPTOR_CHAR,
! 		   ch, NULL, charGetRoom(ch), NULL, cmd, arg, 0))
        retval = 1;
    }
    deleteListIterator(char_i);
--- 637,643 ----
        continue;
      if(try_scripts(SCRIPT_TYPE_COMMAND,
  		   scriptor, SCRIPTOR_CHAR,
! 		   ch, NULL, charGetRoom(ch), cmd, arg, 0))
        retval = 1;
    }
    deleteListIterator(char_i);
***************
*** 652,658 ****
  
  int try_scripts(int script_type,
  		void *me, int me_type,
! 		CHAR_DATA *ch, OBJ_DATA *obj, ROOM_DATA *room, EXIT_DATA *exit,
  		const char *cmd, const char *arg, int narg) {
    int retval = 0;
    LIST *scripts = NULL;
--- 647,653 ----
  
  int try_scripts(int script_type,
  		void *me, int me_type,
! 		CHAR_DATA *ch, OBJ_DATA *obj, ROOM_DATA *room,
  		const char *cmd, const char *arg, int narg) {
    int retval = 0;
    LIST *scripts = NULL;
***************
*** 700,707 ****
        break;
      }
  
!     run_script(scriptGetCode(script), me, me_type,
! 	       ch, obj, room, exit, cmd, arg, narg);    
    }
    deleteList(scripts);
    return retval;
--- 695,702 ----
        break;
      }
  
!     run_script(scriptGetCode(script), me, me_type, ch, obj, room, cmd, 
! 	       arg, narg);    
    }
    deleteList(scripts);
    return retval;
diff -crN nakedmudv1.4/src/scripts/script.h nakedmudv1.5/src/scripts/script.h
*** nakedmudv1.4/src/scripts/script.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/scripts/script.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 199,205 ****
  #define SCRIPTOR_CHAR           0
  #define SCRIPTOR_ROOM           1
  #define SCRIPTOR_OBJ            2
- #define SCRIPTOR_EXIT           3
  
  //
  // initialize the scripting system
--- 199,204 ----
***************
*** 216,222 ****
  // start up a script
  //
  void run_script(const char *script, void *me, int me_type,
! 		CHAR_DATA *ch, OBJ_DATA *obj, ROOM_DATA *room, EXIT_DATA *exit, 
  		const char *cmd, const char *arg, int narg);
  
  //
--- 215,221 ----
  // start up a script
  //
  void run_script(const char *script, void *me, int me_type,
! 		CHAR_DATA *ch, OBJ_DATA *obj, ROOM_DATA *room,
  		const char *cmd, const char *arg, int narg);
  
  //
***************
*** 242,255 ****
  //
  // Try enterance scripts in the given room (the room itself, and mobs)
  //
! void try_enterance_script(CHAR_DATA *ch, ROOM_DATA *room, 
! 			  EXIT_DATA *exit, const char *dirname);
  
  //
  // Try exit scripts in the given room (the room itself, and mobs)
  //
! void try_exit_script(CHAR_DATA *ch, ROOM_DATA *room, 
! 		     EXIT_DATA *exit, const char *dirname);
  
  //
  // Searches for command scripts in the room. If the actual command should
--- 241,252 ----
  //
  // Try enterance scripts in the given room (the room itself, and mobs)
  //
! void try_enterance_script(CHAR_DATA *ch, ROOM_DATA *room, const char *dirname);
  
  //
  // Try exit scripts in the given room (the room itself, and mobs)
  //
! void try_exit_script(CHAR_DATA *ch, ROOM_DATA *room, const char *dirname);
  
  //
  // Searches for command scripts in the room. If the actual command should
***************
*** 267,273 ****
  //
  int try_scripts(int script_type,
  		void *me, int me_type,
! 		CHAR_DATA *ch, OBJ_DATA *obj, ROOM_DATA *room, EXIT_DATA *exit,
  		const char *cmd, const char *arg, int narg);
  
  #endif //__SCRIPT_H
--- 264,270 ----
  //
  int try_scripts(int script_type,
  		void *me, int me_type,
! 		CHAR_DATA *ch, OBJ_DATA *obj, ROOM_DATA *room,
  		const char *cmd, const char *arg, int narg);
  
  #endif //__SCRIPT_H
diff -crN nakedmudv1.4/src/set.c nakedmudv1.5/src/set.c
*** nakedmudv1.4/src/set.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.5/src/set.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 0 ****
--- 1,195 ----
+ //*****************************************************************************
+ //
+ // set.h
+ //
+ // a non-ordered container that has constant lookup time.
+ //
+ //*****************************************************************************
+ 
+ #include <stdlib.h>
+ #include "list.h"
+ #include "set.h"
+ 
+ struct set_data {
+   int       num_buckets;
+   struct list **buckets;
+ };
+ 
+ struct set_iterator {
+   int                curr_bucket; // the bucket number we're currently on
+   struct set_data           *set; // the set we're iterating over
+   struct list_iterator *bucket_i; // the iterator for our current bucket
+ };
+ 
+ 
+ //*****************************************************************************
+ //
+ // local functions
+ //
+ //*****************************************************************************
+ 
+ 
+ //
+ // Find the bucket the set element belongs to
+ //
+ int set_elem_bucket(void *elem, int num_buckets) {
+   // simple for now: just take the modulo
+   return ((int)elem) % num_buckets;
+ };
+ 
+ 
+ //*****************************************************************************
+ //
+ // implementation of set.h
+ //
+ //*****************************************************************************
+ struct set_data *newSet(int num_buckets) {
+   int i;
+ 
+   struct set_data *set = malloc(sizeof(struct set_data));
+   set->buckets = malloc(sizeof(struct list *) * num_buckets);
+ 
+   // all NULL until they actually get a content
+   for(i = 0; i < num_buckets; i++)
+     set->buckets[i] = NULL;
+   set->num_buckets = num_buckets;
+ 
+   return set;
+ };
+ 
+ 
+ void deleteSet(struct set_data *set) {
+   int i;
+ 
+   for(i = 0; i < set->num_buckets; i++)
+     if(set->buckets[i] != NULL)
+       deleteList(set->buckets[i]);
+ 
+   free(set->buckets);
+   free(set);
+ };
+ 
+ 
+ void setPut(struct set_data *set, void *elem) {
+   // find out what bucket we belong to
+   int hash_bucket = set_elem_bucket(elem, set->num_buckets);
+ 
+   // add us to the bucket
+   if(set->buckets[hash_bucket] == NULL)
+     set->buckets[hash_bucket] = newList();
+   // listPut ensures only one copy is in the list
+   listPut(set->buckets[hash_bucket], elem);
+ };
+ 
+ 
+ void setRemove(struct set_data *set, void *elem) {
+   // find out what bucket we belong to
+   int hash_bucket = set_elem_bucket(elem, set->num_buckets);
+ 
+   // see if the bucket exists
+   if(set->buckets[hash_bucket] != NULL)
+     listRemove(set->buckets[hash_bucket], elem);
+ };
+ 
+ 
+ int setIn(struct set_data *set, void *elem) {
+   // find out what bucket we belong to
+   int hash_bucket = set_elem_bucket(elem, set->num_buckets);
+ 
+   if(set->buckets[hash_bucket] != NULL)
+     return listIn(set->buckets[hash_bucket], elem);
+   else
+     return 0;
+ };
+ 
+ 
+ //*****************************************************************************
+ //
+ // set iterator
+ //
+ // we may sometimes want to iterate across all of the elements in a set.
+ // this lets us do so.
+ //
+ //*****************************************************************************
+ struct set_iterator *newSetIterator(struct set_data *S) {
+   struct set_iterator *I = malloc(sizeof(struct set_iterator));
+ 
+   I->set = S;
+   I->curr_bucket = 0;
+   I->bucket_i = NULL;
+   setIteratorReset(I);
+ 
+   return I;
+ }
+ 
+ 
+ void deleteSetIterator(struct set_iterator *I) {
+   if(I->bucket_i) deleteListIterator(I->bucket_i);
+   free(I);
+ }
+ 
+ 
+ void setIteratorReset(struct set_iterator *I) {
+   int i;
+ 
+   if(I->bucket_i) 
+     deleteListIterator(I->bucket_i);
+   I->bucket_i = NULL;
+   I->curr_bucket = 0;
+ 
+   for(i = 0; i < I->set->num_buckets; i++) {
+     if(I->set->buckets[i] == NULL)
+       continue;
+     if(isListEmpty(I->set->buckets[i]))
+       continue;
+     else {
+       I->curr_bucket = i;
+       I->bucket_i = newListIterator(I->set->buckets[i]);
+       break;
+     }
+   }
+ }
+ 
+ 
+ void *setIteratorNext(struct set_iterator *I) {
+   // we have no iterator ... we have no elements left to iterate over!
+   if(I->bucket_i == NULL)
+     return NULL;
+   else {
+     void *elem = listIteratorNext(I->bucket_i);
+     // we're okay ... we have an element
+     if(elem != NULL)
+       return elem;
+     // otherwise, we need to move onto a new bucket
+     else {
+       deleteListIterator(I->bucket_i);
+       I->bucket_i = NULL;
+ 
+       I->curr_bucket++;
+       // find the next non-empty list
+       for(; I->curr_bucket < I->set->num_buckets; I->curr_bucket++) {
+ 	if(I->set->buckets[I->curr_bucket] == NULL)
+ 	  continue;
+ 	if(isListEmpty(I->set->buckets[I->curr_bucket]))
+ 	  continue;
+ 	I->bucket_i = newListIterator(I->set->buckets[I->curr_bucket]);
+ 	break;
+       }
+ 
+       // we've ran out of buckets!
+       if(I->curr_bucket == I->set->num_buckets)
+ 	return NULL;
+       else
+ 	return listIteratorCurrent(I->bucket_i);
+     }
+   }
+ }
+ 
+ 
+ void *setIteratorCurrent(struct set_iterator *I) {
+   // we have no elements!
+   if(I->bucket_i == NULL)
+     return NULL;
+   else
+     return listIteratorCurrent(I->bucket_i);
+ }
diff -crN nakedmudv1.4/src/set.h nakedmudv1.5/src/set.h
*** nakedmudv1.4/src/set.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.5/src/set.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 0 ****
--- 1,34 ----
+ #ifndef SET_H
+ #define SET_H
+ //*****************************************************************************
+ //
+ // set.h
+ //
+ // a non-ordered container that has constant lookup time.
+ //
+ //*****************************************************************************
+ 
+ struct set_data  *newSet(int buckets);
+ void           deleteSet(struct set_data *set);
+ void              setPut(struct set_data *set, void *elem);
+ void           setRemove(struct set_data *set, void *elem);
+ int                setIn(struct set_data *set, void *elem);
+ 
+ 
+ 
+ //*****************************************************************************
+ //
+ // set iterator
+ //
+ // we may sometimes want to iterate across all of the elements in a set.
+ // this lets us do so.
+ //
+ //*****************************************************************************
+ 
+ struct set_iterator *newSetIterator(struct set_data *S);
+ void              deleteSetIterator(struct set_iterator *I);
+ void               setIteratorReset(struct set_iterator *I);
+ void               *setIteratorNext(struct set_iterator *I);
+ void            *setIteratorCurrent(struct set_iterator *I);
+ 
+ #endif // SET_H
diff -crN nakedmudv1.4/src/shop.c nakedmudv1.5/src/shop.c
*** nakedmudv1.4/src/shop.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.5/src/shop.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 0 ****
--- 1,14 ----
+ //*****************************************************************************
+ //
+ // shop.c
+ //
+ // Shops allow mobs or containers to act as stores for selling and buying
+ // other objects.
+ //
+ //*****************************************************************************
+ 
+ struct shop_data {
+ 
+ };
+ 
+ 
diff -crN nakedmudv1.4/src/shop.h nakedmudv1.5/src/shop.h
*** nakedmudv1.4/src/shop.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.5/src/shop.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 0 ****
--- 1,23 ----
+ #ifndef __SHOP_H
+ #define __SHOP_H
+ 
+ //*****************************************************************************
+ //
+ // shop.h
+ //
+ // Shops allow mobs or containers to act as stores for selling and buying
+ // other objects.
+ //
+ //*****************************************************************************
+ 
+ 
+ 
+ SHOP_DATA *newShop   (shop_vnum vnum);
+ void       deleteShop(SHOP_DATA *shop);
+ 
+ void       shopCopyTo(SHOP_DATA *from, SHOP_DATA *to);
+ SHOP_DATA *shopCopy  (SHOP_DATA *shop);
+ 
+ 
+ 
+ #endif // __SHOP_H
diff -crN nakedmudv1.4/src/socials/socials.c nakedmudv1.5/src/socials/socials.c
*** nakedmudv1.4/src/socials/socials.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/socials/socials.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 52,58 ****
      listPut(soc_list, data);
    deleteHashIterator(hash_i);
  
!   store_list(set, "socials", gen_store_list(soc_list, socialStore), NULL);
    deleteList(soc_list);
  
    // write the set
--- 52,58 ----
      listPut(soc_list, data);
    deleteHashIterator(hash_i);
  
!   store_list(set, "socials", gen_store_list(soc_list, socialStore));
    deleteList(soc_list);
  
    // write the set
***************
*** 123,138 ****
  
  STORAGE_SET *socialStore(SOCIAL_DATA *data) {
    STORAGE_SET *set = new_storage_set();
!   store_string(set, "cmds",          data->cmds,                NULL);
!   store_string(set, "to_char_notgt", data->to_char_notgt,       NULL);
!   store_string(set, "to_room_notgt", data->to_room_notgt,       NULL);
!   store_string(set, "to_char_self",  data->to_char_self,        NULL);
!   store_string(set, "to_room_self",  data->to_room_self,        NULL);
!   store_string(set, "to_char_tgt",   data->to_char_tgt,         NULL);
!   store_string(set, "to_vict_tgt",   data->to_vict_tgt,         NULL);
!   store_string(set, "to_room_tgt",   data->to_room_tgt,         NULL);
!   store_string(set, "min_pos",       posGetName(data->min_pos), NULL);
!   store_string(set, "max_pos",       posGetName(data->max_pos), NULL);
    return set;
  }
  
--- 123,138 ----
  
  STORAGE_SET *socialStore(SOCIAL_DATA *data) {
    STORAGE_SET *set = new_storage_set();
!   store_string(set, "cmds",          data->cmds);
!   store_string(set, "to_char_notgt", data->to_char_notgt);
!   store_string(set, "to_room_notgt", data->to_room_notgt);
!   store_string(set, "to_char_self",  data->to_char_self);
!   store_string(set, "to_room_self",  data->to_room_self);
!   store_string(set, "to_char_tgt",   data->to_char_tgt);
!   store_string(set, "to_vict_tgt",   data->to_vict_tgt);
!   store_string(set, "to_room_tgt",   data->to_room_tgt);
!   store_string(set, "min_pos",       posGetName(data->min_pos));
!   store_string(set, "max_pos",       posGetName(data->max_pos));
    return set;
  }
  
diff -crN nakedmudv1.4/src/socket.c nakedmudv1.5/src/socket.c
*** nakedmudv1.4/src/socket.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/socket.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 687,692 ****
--- 687,693 ----
  {
    if(sock_new->page_string) free(sock_new->page_string);
    if(sock_new->text_editor) buffer_free(sock_new->text_editor);
+   if(sock_new->notepad)     free(sock_new->notepad);
  
    bzero(sock_new, sizeof(*sock_new));
    sock_new->control        =  sock;
***************
*** 697,702 ****
--- 698,704 ----
  
    sock_new->text_editor    = NULL;
    sock_new->text_pointer   = NULL;
+   sock_new->notepad        = NULL;
    sock_new->in_text_edit   = FALSE;
    sock_new->max_text_len   = 0;
  
diff -crN nakedmudv1.4/src/socket.h nakedmudv1.5/src/socket.h
*** nakedmudv1.4/src/socket.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/socket.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 34,39 ****
--- 34,40 ----
    bool            in_text_edit;  // are we doing text editing?
    BUFFER        * text_editor;   // where we do our actual work
    char         ** text_pointer;  // where the work will go to
+   char          * notepad;       // a buffer for writing messages of any type
    int             max_text_len;  // the max length we are allowed
    int             editor_mode;   // what mode are we running the editor under?
    int             indent;        // how far do we indent (script editing)
diff -crN nakedmudv1.4/src/storage.c nakedmudv1.5/src/storage.c
*** nakedmudv1.4/src/storage.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/storage.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 26,32 ****
  #define LIST_MARKER           '='
  #define STRING_MARKER         '~'
  #define TYPELESS_MARKER       ' '
- #define COMMENT_MARKER        '#'
  
  
  struct storage_set {
--- 26,31 ----
***************
*** 57,63 ****
  bool list_is_empty(STORAGE_SET_LIST *list);
  bool set_is_empty (STORAGE_SET *set);
  
- void write_storage_comment(FILE *fl, const char *comment, int indent);
  void write_storage_set(STORAGE_SET *set, FILE *fl, int indent);
  void write_storage_list(STORAGE_SET_LIST *list, FILE *fl, int indent);
  void write_storage_data(STORAGE_DATA *data, FILE *fl, int key_width,int indent);
--- 56,61 ----
***************
*** 147,161 ****
  
  
  //
- // write a comment to file
- //
- void write_storage_comment(FILE *fl, const char *comment, int indent) {
-   print_indent(fl, indent);
-   fprintf(fl, "%c %s\n", COMMENT_MARKER, comment);
- }
- 
- 
- //
  // Print a key and the key delimeter to file
  //
  void print_key(FILE *fl, const char *key, int key_width, int indent) {
--- 145,150 ----
***************
*** 365,381 ****
  
  
  //
- // Parse out the comments that are next. If none exist, return NULL
- //
- char *parse_comments(FILE *fl, int indent) {
-   //***********
-   // FINISH ME
-   //***********
-   return NULL;
- }
- 
- 
- //
  // return the type of the data we're dealing with. It is assumed
  // this will be called IMMEDIATELY after parse_key is called
  //
--- 354,359 ----
***************
*** 468,474 ****
      switch(type) {
      case TYPELESS_MARKER: {
        char *line = parse_line(fl);
!       store_string(set, key, line, NULL);
        free(line);
        break;
      }
--- 446,452 ----
      switch(type) {
      case TYPELESS_MARKER: {
        char *line = parse_line(fl);
!       store_string(set, key, line);
        free(line);
        break;
      }
***************
*** 476,494 ****
      case STRING_MARKER: {
        fgetc(fl); // kill the newline
        char *string = parse_string(fl, indent+2);
!       store_string(set, key, string, NULL);
        free(string);
        break;
      }
  
      case SET_MARKER:
        fgetc(fl); // kill the newline
!       store_set(set, key, parse_storage_set(fl, indent+2), NULL);
        break;
  
      case LIST_MARKER:
        fgetc(fl); // kill the newline
!       store_list(set, key, parse_storage_list(fl, indent+2), NULL);
        break;
      }
      free(key);
--- 454,472 ----
      case STRING_MARKER: {
        fgetc(fl); // kill the newline
        char *string = parse_string(fl, indent+2);
!       store_string(set, key, string);
        free(string);
        break;
      }
  
      case SET_MARKER:
        fgetc(fl); // kill the newline
!       store_set(set, key, parse_storage_set(fl, indent+2));
        break;
  
      case LIST_MARKER:
        fgetc(fl); // kill the newline
!       store_list(set, key, parse_storage_list(fl, indent+2));
        break;
      }
      free(key);
***************
*** 576,608 ****
  }
  
  
! void   store_set(STORAGE_SET *set, const char *key, STORAGE_SET *val,
! 		 const char *comment) {
    storage_put(set, new_data_set(val, key));
  }
  
! void   store_list(STORAGE_SET *set, const char *key, STORAGE_SET_LIST *val,
! 		  const char *comment) {
    storage_put(set, new_data_list(val, key));
  }
  
! void store_string(STORAGE_SET *set, const char *key, const char *val,
! 		  const char *comment) {
    storage_put(set, new_data_string(val, key));
  }
  
! void store_double(STORAGE_SET *set, const char *key, double val, 
! 		  const char *comment) {
    storage_put(set, new_data_double(val, key));
  }
  
! void store_int(STORAGE_SET *set, const char *key, int val, 
! 	       const char *comment) {
    storage_put(set, new_data_int(val, key));
  }
  
! void store_long(STORAGE_SET *set, const char *key, long val, 
! 	       const char *comment) {
    storage_put(set, new_data_long(val, key));
  }
  
--- 554,580 ----
  }
  
  
! void   store_set(STORAGE_SET *set, const char *key, STORAGE_SET *val) {
    storage_put(set, new_data_set(val, key));
  }
  
! void   store_list(STORAGE_SET *set, const char *key, STORAGE_SET_LIST *val) {
    storage_put(set, new_data_list(val, key));
  }
  
! void store_string(STORAGE_SET *set, const char *key, const char *val) {
    storage_put(set, new_data_string(val, key));
  }
  
! void store_double(STORAGE_SET *set, const char *key, double val) {
    storage_put(set, new_data_double(val, key));
  }
  
! void store_int(STORAGE_SET *set, const char *key, int val) {
    storage_put(set, new_data_int(val, key));
  }
  
! void store_long(STORAGE_SET *set, const char *key, long val) {
    storage_put(set, new_data_long(val, key));
  }
  
***************
*** 611,617 ****
    if(data) 
      return data->set_val;
    else {
!     store_set(set, key, new_storage_set(), NULL);
      return read_set(set, key);
    }
  }
--- 583,589 ----
    if(data) 
      return data->set_val;
    else {
!     store_set(set, key, new_storage_set());
      return read_set(set, key);
    }
  }
***************
*** 621,627 ****
    if(data) 
      return data->list_val;
    else {
!     store_list(set, key, new_storage_list(), NULL);
      return read_list(set, key);
    }
  }
--- 593,599 ----
    if(data) 
      return data->list_val;
    else {
!     store_list(set, key, new_storage_list());
      return read_list(set, key);
    }
  }
diff -crN nakedmudv1.4/src/storage.h nakedmudv1.5/src/storage.h
*** nakedmudv1.4/src/storage.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/storage.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 59,76 ****
  //
  // store various datatypes to the storage data
  //
! void    store_set(STORAGE_SET *set, const char *key, STORAGE_SET *val,
! 		  const char *comment);
! void   store_list(STORAGE_SET *set, const char *key, STORAGE_SET_LIST *val,
! 		  const char *comment);
! void store_string(STORAGE_SET *set, const char *key, const char *val,
! 		  const char *comment);
! void store_double(STORAGE_SET *set, const char *key, double val,
! 		  const char *comment);
! void    store_int(STORAGE_SET *set, const char *key, int val,
! 		  const char *comment);
! void   store_long(STORAGE_SET *set, const char *key, long val,
! 		  const char *comment);
  
  
  //
--- 59,70 ----
  //
  // store various datatypes to the storage data
  //
! void    store_set(STORAGE_SET *set, const char *key, STORAGE_SET *val);
! void   store_list(STORAGE_SET *set, const char *key, STORAGE_SET_LIST *val);
! void store_string(STORAGE_SET *set, const char *key, const char *val);
! void store_double(STORAGE_SET *set, const char *key, double val);
! void    store_int(STORAGE_SET *set, const char *key, int val);
! void   store_long(STORAGE_SET *set, const char *key, long val);
  
  
  //
diff -crN nakedmudv1.4/src/text_editor.c nakedmudv1.5/src/text_editor.c
*** nakedmudv1.4/src/text_editor.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/text_editor.c	2010-11-01 15:54:17.000000000 -0500
***************
*** 274,282 ****
        break;
  
      case 'l':
!     case 'L':
        text_editor_display(sock, sock->editor_mode, TRUE);
        break;
  
      case 'f':
      case 'F':
--- 274,291 ----
        break;
  
      case 'l':
!     case 'L': {
        text_editor_display(sock, sock->editor_mode, TRUE);
+       if(sock->editor_mode == EDITOR_MODE_NORMAL) {
+ 	int linecount = 0;
+ 	if(buffer_string(sock->text_editor))
+ 	  linecount = count_letters(buffer_string(sock->text_editor), '\n', 
+ 				    strlen(buffer_string(sock->text_editor)));
+ 	send_to_socket(sock, "%d line%s displayed.\r\n", linecount,
+ 		       (linecount == 1 ? "" : "s"));
+       }
        break;
+     }
  
      case 'f':
      case 'F':
***************
*** 393,398 ****
--- 402,413 ----
    }
  }
  
+ void start_notepad(SOCKET_DATA *sock, const char *txt, int max_len, 
+ 		   int mode) {
+   if(sock->notepad) free(sock->notepad);
+   sock->notepad = strdup(txt ? txt : "");
+   start_text_editor(sock, &sock->notepad, max_len, mode);
+ }
  
  void start_text_editor( SOCKET_DATA *sock, char **text, int max_len, int mode) {
    // we're already in edit mode ... don't mess around
diff -crN nakedmudv1.4/src/text_editor.h nakedmudv1.5/src/text_editor.h
*** nakedmudv1.4/src/text_editor.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/text_editor.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 16,20 ****
--- 16,22 ----
  
  void start_text_editor(SOCKET_DATA *sock, char **text, int max_len, int mode);
  void text_editor_loop (SOCKET_DATA *sock, char *arg);
+ void start_notepad    (SOCKET_DATA *sock, const char *txt, int max_len, 
+ 		       int mode);
  
  #endif //__TEXT_EDITOR_H
diff -crN nakedmudv1.4/src/time/mudtime.h nakedmudv1.5/src/time/mudtime.h
*** nakedmudv1.4/src/time/mudtime.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv1.5/src/time/mudtime.h	2010-11-01 15:54:17.000000000 -0500
***************
*** 4,10 ****
  //
  // mudtime.h
  //
! // A small module for handling time of day in the MUD.
  //
  //*****************************************************************************
  
--- 4,11 ----
  //
  // mudtime.h
  //
! // We can't use time.c, because it is a standard C header. A small module for
! // handling time of day in the MUD.
  //
  //*****************************************************************************
  
